-------------------------------------------------------------------------
--Created by Papaew
-------------------------------------------------------------------------

ffi.cdef[[
typedef struct { double a1,b1,c1,d1, 
						a2,b2,c2,d2,
						a3,b3,c3,d3,
						a4,b4,c4,d4; } mat_4;
]]

mat4 = function(a1,b1,c1,d1, a2,b2,c2,d2, a3,b3,c3,d3, a4,b4,c4,d4)
	if type(a1) == "table" then
		return _mat4(unpack(a1))
	elseif type(a1) == "number" then
		return _mat4(a1,b1,c1,d1, a2,b2,c2,d2, a3,b3,c3,d3, a4,b4,c4,d4)
	elseif type(a1) == "nil" then
		return _mat4(0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0)
	end
end

_mat4 = {}
local mt = {
	__index = {
	unpack = function(a) return {a.a1,a.b1,a.c1,a.d1, a.a2,a.b2,a.c2,a.d2, a.a3,a.b3,a.c3,a.d3, a.a4,a.b4,a.c4,a.d4} end,
	--set = function(a, x,y) a.x, a.y = x,y end,
	normalize = function(a)
					local len = 0
					len = a.a1*a.a1 + a.b1*a.b1 + a.c1*a.c1 + a.d1*a.d1 + a.a2*a.a2 + a.b2*a.b2 + a.c2*a.c2 + a.d2*a.d2 + a.a3*a.a3 + a.b3*a.b3 + a.c3*a.c3 + a.d3*a.d3 + a.a4*a.a4 + a.b4*a.b4 + a.c4*a.c4 + a.d4*a.d4
					len = math.sqrt(len)
					return _mat4(a.a1/len,a.b1/len,a.c1/len,a.d1/len, a.a2/len,a.b2/len,a.c2/len,a.d2/len, a.a3/len,a.b3/len,a.c3/len,a.d3/len, a.a4/len,a.b4/len,a.c4/len,a.d4/len)
				end,
	copy = function(a) return _mat4(a.a1,a.b1,a.c1,a.d1, a.a2,a.b2,a.c2,a.d2, a.a3,a.b3,a.c3,a.d3, a.a4,a.b4,a.c4,a.d4) end,
	},
	__add = function(a,b)
				if type(a) == 'mat4' and type(b) == 'mat4' then
					return _mat4(a.a1+b.a1, a.b1+b.b1, a.c1+b.c1, a.d1+b.d1,
								 a.a2+b.a2, a.b2+b.b2, a.c2+b.c2, a.d2+b.d2,
								 a.a3+b.a3, a.b3+b.b3, a.c3+b.c3, a.d3+b.d3,
								 a.a4+b.a4, a.b4+b.b4, a.c4+b.c4, a.d4+b.d4)
				end
			end,
	__sub = function(a,b)
				if type(a) == 'mat4' and type(b) == 'mat4' then
					return _mat4(a.a1-b.a1, a.b1-b.b1, a.c1-b.c1, a.d1-b.d1,
								 a.a2-b.a2, a.b2-b.b2, a.c2-b.c2, a.d2-b.d2,
								 a.a3-b.a3, a.b3-b.b3, a.c3-b.c3, a.d3-b.d3,
								 a.a4-b.a4, a.b4-b.b4, a.c4-b.c4, a.d4-b.d4)
				end
			end,
	__mul = function(a,b)
				if type(a) == 'mat4' and type(b) == 'mat4' then
					return _mat4(a.a1*b.a1+a.b1*b.a2+a.c1*b.a3+a.d1*b.a4, a.a1*b.b1+a.b1*b.b2+a.c1*b.b3+a.d1*b.b4, a.a1*b.c1+a.b1*b.c2+a.c1*b.c3+a.d1*b.c4, a.a1*b.d1+a.b1*b.d2+a.c1*b.d3+a.d1*b.d4,
								 a.a2*b.a1+a.b2*b.a2+a.c2*b.a3+a.d2*b.a4, a.a2*b.b1+a.b2*b.b2+a.c2*b.b3+a.d2*b.b4, a.a2*b.c1+a.b2*b.c2+a.c2*b.c3+a.d2*b.c4, a.a2*b.d1+a.b2*b.d2+a.c2*b.d3+a.d2*b.d4,
								 a.a3*b.a1+a.b3*b.a2+a.c3*b.a3+a.d3*b.a4, a.a3*b.b1+a.b3*b.b2+a.c3*b.b3+a.d3*b.b4, a.a3*b.c1+a.b3*b.c2+a.c3*b.c3+a.d3*b.c4, a.a3*b.d1+a.b3*b.d2+a.c3*b.d3+a.d3*b.d4,
								 a.a4*b.a1+a.b4*b.a2+a.c4*b.a3+a.d4*b.a4, a.a4*b.b1+a.b4*b.b2+a.c4*b.b3+a.d4*b.b4, a.a4*b.c1+a.b4*b.c2+a.c4*b.c3+a.d4*b.c4, a.a4*b.d1+a.b4*b.d2+a.c4*b.d3+a.d4*b.d4)
				elseif type(a) == 'mat4' and type(b) == 'vec4' then
					return _vec4(a.a1*b.x+a.b1*b.y+a.c1*b.z+a.d1*b.w,
								 a.a2*b.x+a.b2*b.y+a.c2*b.z+a.d2*b.w,
								 a.a3*b.x+a.b3*b.y+a.c3*b.z+a.d3*b.w,
								 a.a4*b.x+a.b4*b.y+a.c4*b.z+a.d4*b.w)
				elseif type(a) == 'vec4' and type(b) == 'mat4' then
					return _vec4(b.a1*a.x+b.b1*a.y+b.c1*a.z+b.d1*a.w,
								 b.a2*a.x+b.b2*a.y+b.c2*a.z+b.d2*a.w,
								 b.a3*a.x+b.b3*a.y+b.c3*a.z+b.d3*a.w,
								 b.a4*a.x+b.b4*a.y+b.c4*a.z+b.d4*a.w)
				end
			end,
	__eq  = function(a,b)
				 if a.a1==b.a1 and a.b1==b.b1 and a.c1==b.c1 and a.d1==b.d1 and
					a.a2==b.a2 and a.b2==b.b2 and a.c2==b.c2 and a.d2==b.d2 and
					a.a3==b.a3 and a.b3==b.b3 and a.c3==b.c3 and a.d3==b.d3 and
					a.a4==b.a4 and a.b4==b.b4 and a.c4==b.c4 and a.d4==b.d4 then
					return true else return false end
			end,
	__tostring = function(a) return "["..a.a1..", "..a.b1..", "..a.c1..", "..a.d1.."]\n[".. 
										a.a2..", "..a.b2..", "..a.c2..", "..a.d2.."]\n[".. 
										a.a3..", "..a.b3..", "..a.c3..", "..a.d3.."]\n[".. 
										a.a4..", "..a.b4..", "..a.c4..", "..a.d4.."]" end,
	__unm = function(a) return _mat4(-a.x, -a.y) end,
	__pow = function(a,b) return _mat4(a.x^b, a.y^b) end
}
_mat4 = ffi.metatype('mat_4', mt)